package com.daixinet.springbootdemo.controller;

import com.daixinet.springbootdemo.config.SocketSessionRegistry;
import org.springframework.messaging.MessageHeaders;
import org.springframework.messaging.handler.annotation.MessageMapping;
import org.springframework.messaging.simp.SimpMessageHeaderAccessor;
import org.springframework.messaging.simp.SimpMessageType;
import org.springframework.messaging.simp.SimpMessagingTemplate;
import org.springframework.stereotype.Controller;

import javax.annotation.Resource;

@Controller
public class WebSocketTestController {
    @Resource
    private SimpMessagingTemplate messagingTemplate;
    @Resource
    SocketSessionRegistry webAgentSessionRegistry;

    @MessageMapping("/testQueueSend")
    //@SendToUser("/queueSender/queueSend")
    public void testReceiveAndQueueSend(InMessage message) {
        String sessionId = webAgentSessionRegistry.getSessionIds(message.getName()).stream().findFirst().get();
        messagingTemplate.convertAndSendToUser(sessionId, "/queueSender/queueSend", "收到消息：" + message.getMessage(), createHeaders(sessionId));
    }

    private MessageHeaders createHeaders(String sessionId) {
        SimpMessageHeaderAccessor headerAccessor = SimpMessageHeaderAccessor.create(SimpMessageType.MESSAGE);
        headerAccessor.setSessionId(sessionId);
        headerAccessor.setLeaveMutable(true);
        return headerAccessor.getMessageHeaders();
    }

    @MessageMapping("/testTopicSend")
    //@SendTo("/topicSender/topicSend")
    public void testReceiveAndTopicSend(String message) {
        messagingTemplate.convertAndSend("/topicSender/topicSend", "收到消息：" + message + ",并且发送给了所有人");
    }
}
